//package com.muyu.config;
//
//import com.muyu.common.core.domain.Result;
//import com.muyu.ruleEngine.context.DataModelContextHolder;
//import com.muyu.ruleEngine.context.DataSetContextHolder;
//import com.muyu.ruleEngine.context.RecordContextHolder;
//import com.muyu.ruleEngine.domain.EngineVersion;
//import com.muyu.ruleEngine.domain.req.EngineVersionTestReq;
//import com.muyu.ruleEngine.dynamicLoad.DynamicLoader;
//import com.muyu.ruleEngine.model.DataModel;
//import com.muyu.ruleEngine.model.DataSetModel;
//import com.muyu.ruleEngine.model.RecordModel;
//import com.muyu.ruleEngine.model.process.DataProcessModel;
//import com.muyu.ruleEngine.model.process.DataSetProcessModel;
//import com.muyu.ruleEngine.model.process.RecordProcessModel;
//import com.muyu.source.engine.client.ruleEngineInit.RuleEngineInit;
//import com.muyu.source.remote.RemoteVersionService;
//import lombok.extern.log4j.Log4j2;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.context.annotation.ComponentScan;
//import org.springframework.context.annotation.Import;
//
//import java.lang.reflect.Method;
//import java.util.ArrayList;
//import java.util.List;
//import java.util.Map;
//
///**
// * 规则引擎客户端配置类
// *
// * @author qdm
// * on 2024/5/9 星期四
// */
//@Log4j2
//@ComponentScan
//@Import(value = {RuleEngineClientRunner.class})
//public class RuleEngineClientConfig {
//
//    @Autowired
//    private RemoteVersionService remoteVersionService;
//
//    public Result engineVersionTest(EngineVersionTestReq testReq) {
//        if (testReq.getScope() == 4) {
//            DataProcessModel dataProcessModel = DataProcessModel.builder().dataModel(testReq.getDataModel()).build();
//            DataModelContextHolder.set(dataProcessModel);
//        } else if (testReq.getScope() == 3) {
//            RecordModel recordModel = RecordModel.builder().dataModels(testReq.getDataModelList()).build();
//            RecordProcessModel recordProcessModel = RecordProcessModel.builder()
//                    .keys(testReq.getKeys())
//                    .recordModel(recordModel)
//                    .build();
//            RecordContextHolder.set(recordProcessModel);
//        } else if (testReq.getScope() == 2) {
//            List<RecordModel> recordModelList = new ArrayList<>();
//            List<List<DataModel>> dataModelLists = testReq.getDataModelLists();
//            dataModelLists.stream().forEach(dataModelList -> {
//                RecordModel recordModel = RecordModel.builder().dataModels(dataModelList).build();
//                recordModelList.add(recordModel);
//            });
//            DataSetModel dataSetModel = DataSetModel.builder()
//                    .recordModels(recordModelList)
//                    .build();
//            DataSetProcessModel dataSetProcessModel = DataSetProcessModel.builder()
//                    .dataSetModel(dataSetModel)
//                    .build();
//            DataSetContextHolder.set(dataSetProcessModel);
//        }
//        Result<EngineVersion> versionResult = remoteVersionService.getVersion(testReq.getEngineVersionId());
//        EngineVersion engineVersion = versionResult.getData();
//        Map<String, byte[]> engineMap = RuleEngineInit.getEngineMap(testReq.getEngineVersionId());
//
//        try {
//            @SuppressWarnings("resource")
//            DynamicLoader.MemoryClassLoader classLoader = new DynamicLoader.MemoryClassLoader(engineMap);
//            Class<?> aClass = classLoader.loadClass(engineVersion.getVersionClass());
//            Method method = aClass.getDeclaredMethod("execution");
//            Object o = aClass.newInstance();
//            method.invoke(o);
//        } catch (Exception e) {
//            log.info(e.getMessage());
//            return Result.success("程序异常: 信息[" + e.getLocalizedMessage() + "]异常");
//        }
//        return Result.success("测试正常,无异常数据返回");
//    }
//}
