package com.muyu.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.muyu.common.core.annotation.Excel;
import com.muyu.common.core.web.domain.BaseEntity;
import com.muyu.req.EngineMaintenanceEditReq;
import com.muyu.req.EngineMaintenanceQueryReq;
import com.muyu.req.EngineMaintenanceSaveReq;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.util.Date;
import java.util.function.Supplier;

/**
 * 引擎维护对象 engine_maintenance
 *
 * @author qdm
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@TableName("engine_maintenance")
@EqualsAndHashCode(callSuper = true)
public class EngineMaintenance extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /** 编号 */
    @TableId(value = "id",type = IdType.AUTO)
    private Long id;

    /** 名称 */
    @Excel(name = "名称")
    private String name;

    /** 类型 */
    @Excel(name = "类型")
    private Integer type;

    /** 作用域 */
    @Excel(name = "作用域")
    private Integer scope;

    /** 引擎编码 */
    @Excel(name = "引擎编码")
    private String engineCode;

    /** 是否激活 */
    @Excel(name = "是否激活")
    private String isActivate;

    /** 状态 */
    @Excel(name = "状态")
    private String status;

    /** 描述 */
    @Excel(name = "描述")
    private String description;



    /**
    * 查询构造器
    */
    public static EngineMaintenance queryBuild(EngineMaintenanceQueryReq engineMaintenanceQueryReq){
        return EngineMaintenance.builder()
                .name(engineMaintenanceQueryReq.getName())
                .type(engineMaintenanceQueryReq.getType())
                .scope(engineMaintenanceQueryReq.getScope())
                .engineCode(engineMaintenanceQueryReq.getEngineCode())
                .isActivate(engineMaintenanceQueryReq.getIsActivate())
                .status(engineMaintenanceQueryReq.getStatus())
                .build();
    }

    /**
    * 添加构造器
    */
    public static EngineMaintenance saveBuild(EngineMaintenanceSaveReq engineMaintenanceSaveReq, Supplier<String> createBy){
        return EngineMaintenance.builder()
                .name(engineMaintenanceSaveReq.getName())
                .type(engineMaintenanceSaveReq.getType())
                .scope(engineMaintenanceSaveReq.getScope())
                .engineCode(engineMaintenanceSaveReq.getEngineCode())
                .isActivate(engineMaintenanceSaveReq.getIsActivate())
                .status(engineMaintenanceSaveReq.getStatus())
                .description(engineMaintenanceSaveReq.getDescription())
                .remark(engineMaintenanceSaveReq.getRemark())
            .createBy(createBy.get())
            .createTime(new Date())
            .build();
    }

    /**
    * 修改构造器
    */
    public static EngineMaintenance editBuild(Long id, EngineMaintenanceEditReq engineMaintenanceEditReq, Supplier<String> updateBy){
        return EngineMaintenance.builder()
            .id(id)
                .name(engineMaintenanceEditReq.getName())
                .type(engineMaintenanceEditReq.getType())
                .scope(engineMaintenanceEditReq.getScope())
                .engineCode(engineMaintenanceEditReq.getEngineCode())
                .isActivate(engineMaintenanceEditReq.getIsActivate())
                .status(engineMaintenanceEditReq.getStatus())
                .description(engineMaintenanceEditReq.getDescription())
                .remark(engineMaintenanceEditReq.getRemark())
            .updateBy(updateBy.get())
            .updateTime(new Date())
            .build();
    }

}
